package com.minemaarten.signals.client;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;
import net.minecraftforge.client.event.RenderWorldLastEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

import org.lwjgl.opengl.GL11;

import com.minemaarten.signals.block.BlockSignalBase;
import com.minemaarten.signals.client.render.signals.BlockSectionRenderer;
import com.minemaarten.signals.init.ModItems;
import com.minemaarten.signals.tileentity.TileEntitySignalBase;
import com.minemaarten.signals.tileentity.TileEntityStationMarker;

public class ClientEventHandler{

    private final BlockSectionRenderer blockSectionRenderer = new BlockSectionRenderer();

    @SubscribeEvent
    public void onWorldRender(RenderWorldLastEvent event){
        Tessellator t = Tessellator.func_178181_a();
        BufferBuilder b = t.func_178180_c();

        EntityPlayer player = Minecraft.func_71410_x().field_71439_g;
        if(!shouldRender()) return;

        double playerX = player.field_70169_q + (player.field_70165_t - player.field_70169_q) * event.getPartialTicks();
        double playerY = player.field_70167_r + (player.field_70163_u - player.field_70167_r) * event.getPartialTicks();
        double playerZ = player.field_70166_s + (player.field_70161_v - player.field_70166_s) * event.getPartialTicks();
        GL11.glPushMatrix();
        GL11.glTranslated(-playerX, -playerY, -playerZ);

        GL11.glPointSize(10);

        GlStateManager.func_179090_x();
        GlStateManager.func_179140_f();
        b.func_178969_c(0, 0, 0);

        List<TileEntity> tes = player.field_70170_p.field_147482_g;
        /*if(player.isSneaking())*/blockSectionRenderer.render(b, tes);

        b.func_181668_a(GL11.GL_LINES, DefaultVertexFormats.field_181706_f);

        List<TileEntityStationMarker> markers = new ArrayList<>();
        for(TileEntity te : tes) {
            if(player.func_70093_af() && te instanceof TileEntitySignalBase) {
                TileEntitySignalBase teSignal = (TileEntitySignalBase)te;

                for(TileEntitySignalBase signal : teSignal.getNextSignals()) {
                    drawBetween(b, signal.func_174877_v(), te.func_174877_v(), 0.5, 1, 1, 1, 1);
                }
            } else if(te instanceof TileEntityStationMarker) {
                markers.add((TileEntityStationMarker)te);
            }
        }
        for(int i = 0; i < markers.size(); i++) {
            TileEntityStationMarker marker1 = markers.get(i);
            for(int j = 0; j < i; j++) {
                TileEntityStationMarker marker2 = markers.get(j);
                if(marker1.getStationName().equals(marker2.getStationName())) {
                    drawBetween(b, marker1.func_174877_v(), marker2.func_174877_v(), 1, 0, 1, 0, 1);
                }
            }
        }
        //for(RailWrapper rail : rails) {
        //              wr.pos(rail.getX() + 0.5, rail.getY() + 0.5, rail.getZ() + 0.5).color(1F, 1F, 1F, 1F).endVertex();
        //}

        t.func_78381_a();

        GlStateManager.func_179098_w();
        GlStateManager.func_179145_e();
        GL11.glPopMatrix();
    }

    private boolean shouldRender(){
        Minecraft mc = Minecraft.func_71410_x();
        EntityPlayer player = mc.field_71439_g;
        Item item = player.field_71071_by.func_70448_g().func_77973_b();
        if(item == ModItems.RAIL_CONFIGURATOR || (item instanceof ItemBlock) && ((ItemBlock)item).func_179223_d() instanceof BlockSignalBase) {
            return true;
        }

        RayTraceResult ray = Minecraft.func_71410_x().field_71476_x;
        return ray.field_72313_a == RayTraceResult.Type.BLOCK && player.field_70170_p.func_180495_p(ray.func_178782_a()).func_177230_c() instanceof BlockSignalBase;
    }

    private void drawBetween(BufferBuilder buffer, BlockPos p1, BlockPos p2, double offset, float r, float g, float b, float a){
        drawBetween(buffer, p1, p2, offset, offset, r, g, b, a);
    }

    private static void drawBetween(BufferBuilder buffer, BlockPos p1, BlockPos p2, double offset1, double offset2, float r, float g, float b, float alpha){
        buffer.func_181662_b(p1.func_177958_n() + 0.5, p1.func_177956_o() + offset1, p1.func_177952_p() + 0.5).func_181666_a(r, g, b, alpha).func_181675_d();
        buffer.func_181662_b(p2.func_177958_n() + 0.5, p2.func_177956_o() + offset2, p2.func_177952_p() + 0.5).func_181666_a(r, g, b, alpha).func_181675_d();
    }
}
