package com.minemaarten.signals.event;

import java.util.List;

import net.minecraft.block.BlockRailBase;
import net.minecraft.block.BlockRailBase.EnumRailDirection;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraftforge.event.entity.player.PlayerInteractEvent.RightClickBlock;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

import com.minemaarten.signals.api.IRail;
import com.minemaarten.signals.rail.RailManager;

public class RailReplacerEventHandler{

    /**
     * Makes it so when a player right clicks a rail block with a different rail item, it will be replaced, without having to remove and place a rail.
     * @param e
     */
    @SubscribeEvent
    public void onBlockInteraction(RightClickBlock e){
        if(!e.getWorld().field_72995_K && e.getFace() == EnumFacing.UP) {
            ItemStack stack = e.getEntityPlayer().func_184614_ca();
            BlockRailBase railBlock = getRailBlock(stack);
            if(railBlock != null) {
                IBlockState state = e.getWorld().func_180495_p(e.getPos());
                IRail rail = RailManager.getInstance().getRail(e.getWorld(), e.getPos(), state);
                if(rail != null && state.func_177230_c() != railBlock) {
                    EnumRailDirection dir = rail.getDirection(e.getWorld(), e.getPos(), state);
                    e.getWorld().func_175655_b(e.getPos(), !e.getEntityPlayer().func_184812_l_());
                    List<EntityItem> drops = e.getWorld().func_72872_a(EntityItem.class, new AxisAlignedBB(e.getPos()));
                    for(EntityItem drop : drops) {
                        drop.func_174867_a(0);
                        drop.func_70100_b_(e.getEntityPlayer());
                    }

                    e.getWorld().func_175656_a(e.getPos(), railBlock.func_176223_P());
                    if(!e.getEntityPlayer().func_184812_l_()) stack.func_190918_g(1);

                    //Set the rail orientation equal to the old rail, if possible.
                    if(railBlock.func_176560_l().func_177700_c().contains(dir)) {
                        IBlockState curState = e.getWorld().func_180495_p(e.getPos());
                        e.getWorld().func_175656_a(e.getPos(), curState.func_177226_a(railBlock.func_176560_l(), dir));
                    }
                }
            }
        }
    }

    private static BlockRailBase getRailBlock(ItemStack stack){
        if(stack.func_77973_b() instanceof ItemBlock) {
            ItemBlock item = (ItemBlock)stack.func_77973_b();
            return item.func_179223_d() instanceof BlockRailBase ? (BlockRailBase)item.func_179223_d() : null; //Only allow simple registered IRails to be placed
        }
        return null;
    }
}
