package com.minemaarten.signals.lib;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.block.BlockRailBase.EnumRailDirection;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.math.BlockPos;

import com.minemaarten.signals.rail.RailWrapper;

public class SignalBlockNode{
    public final List<SignalBlockNode> nextNeighbors = new ArrayList<>();
    public final BlockPos railPos;
    public final EnumRailDirection railDir;

    public SignalBlockNode(RailWrapper railWrapper){
        this(railWrapper, railWrapper.getRailDir());
    }

    public SignalBlockNode(BlockPos railPos, EnumRailDirection railDir){
        this.railPos = railPos;
        this.railDir = railDir;
    }

    public SignalBlockNode(NBTTagCompound tag){
        railPos = new BlockPos(tag.func_74762_e("x"), tag.func_74762_e("y"), tag.func_74762_e("z"));
        railDir = EnumRailDirection.values()[tag.func_74771_c("railDir")];

        NBTTagList tagList = tag.func_150295_c("blockNode", 10);
        for(int i = 0; i < tagList.func_74745_c(); i++) {
            NBTTagCompound t = tagList.func_150305_b(i);

            SignalBlockNode neighbor = new SignalBlockNode(t);
            nextNeighbors.add(neighbor);
        }
    }

    public void toNBTTagCompound(NBTTagCompound tag){
        tag.func_74768_a("x", railPos.func_177958_n());
        tag.func_74768_a("y", railPos.func_177956_o());
        tag.func_74768_a("z", railPos.func_177952_p());
        tag.func_74774_a("railDir", (byte)railDir.ordinal());

        NBTTagList tagList = new NBTTagList();
        for(SignalBlockNode neighbor : nextNeighbors) {
            NBTTagCompound t = new NBTTagCompound();
            neighbor.toNBTTagCompound(t);
            tagList.func_74742_a(t);
        }
        tag.func_74782_a("blockNode", tagList);
    }

    @Override
    public boolean equals(Object obj){
        return obj instanceof SignalBlockNode && ((SignalBlockNode)obj).railPos.equals(railPos);
    }

    @Override
    public int hashCode(){
        return railPos.hashCode();
    }
}
