package com.minemaarten.signals.tileentity;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ITickable;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.common.DimensionManager;

import com.minemaarten.signals.block.BlockRailLink;
import com.minemaarten.signals.rail.RailCacheManager;
import com.minemaarten.signals.rail.RailWrapper;

public class TileEntityRailLink extends TileEntityBase implements ITickable{
    private BlockPos linkedPos;
    private int linkedDimension;
    private RailWrapper linkedRail;

    public RailWrapper getLinkedRail(){
        if(linkedRail == null && linkedPos != null) {
            World linkedWorld = DimensionManager.getWorld(linkedDimension);
            if(linkedWorld != null) {
                if(linkedWorld.func_175668_a(linkedPos, false)) {
                    RailWrapper rail = RailCacheManager.getInstance(linkedDimension).getRail(linkedWorld, linkedPos);
                    if(rail != null) {
                        setLinkedRail(rail);
                    }
                    return rail;
                }
            }
        }
        return linkedRail;
    }

    public void onLinkedRailInvalidated(){
        linkedRail = null;
        updateLinkState();
    }

    public void setLinkedRail(RailWrapper rail){
        if(rail != linkedRail) {
            if(linkedRail != null) {
                linkedRail.unlink(this);
            }
            if(rail != null) {
                rail.link(this);
                linkedRail = rail;
                linkedPos = rail;
                linkedDimension = rail.world.field_73011_w.getDimension();
            } else {
                linkedPos = null;
                linkedDimension = 0;
            }
            updateLinkState();
        }
    }

    private void updateLinkState(){
        field_145850_b.func_180501_a(func_174877_v(), field_145850_b.func_180495_p(func_174877_v()).func_177226_a(BlockRailLink.CONNECTED, linkedRail != null), 2);
	    field_145850_b.func_175685_c(func_174877_v(), func_145838_q(), true); //Guarantee a block update
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag){
        if(linkedPos != null) {
            tag.func_74768_a("linkedX", linkedPos.func_177958_n());
            tag.func_74768_a("linkedY", linkedPos.func_177956_o());
            tag.func_74768_a("linkedZ", linkedPos.func_177952_p());
        }
        tag.func_74768_a("linkedDim", linkedDimension);

        return super.func_189515_b(tag);
    }

    @Override
    public void func_145839_a(NBTTagCompound tag){
        if(tag.func_74764_b("linkedX")) {
            linkedPos = new BlockPos(tag.func_74762_e("linkedX"), tag.func_74762_e("linkedY"), tag.func_74762_e("linkedZ"));
        } else {
            linkedPos = null;
        }
        linkedDimension = tag.func_74762_e("linkedDim");

        super.func_145839_a(tag);
    }

    @Override
    public void func_73660_a(){
        if(!field_145850_b.field_72995_K && field_145850_b.func_82737_E() % 100 == 0) getLinkedRail();
    }
}
